You are not logged in.

#1 2021-06-27 10:48:16

ExoticCandy
Member
Registered: 2021-06-24
Posts: 13

[SOLVED] Need to install monodevelop, not available on AUR

Greetings everyone.

I have been scratching my head for the past 2 days to install monodevelop on my arch. the developers maintain it really well for ubuntu and debian, but i have no clue why they pay no attention to arch.
I tried to install the outdated package in AUR (https://aur.archlinux.org/packages/monodevelop-stable/)

The steps leading to the problem (that made me go for the next failed option)
1) tried to install it, but the dependecy "fsharp" and "msbuild-stable" are removed.
2) assumed the package in the parenthesis would be a replacement, tried to install (https://aur.archlinux.org/packages/ghost-deps-meta/) and it has conflicting dependencies with the packages i need for other applications.
3) tried to find a work around, but failed. i would appreciate to hear it, if there is any (a link to the wiki would suffice, i didn't find anything related to my problem)

The I found flatpak installer for monodevelop on their repository. (yet again, outdated)
the installer was pointing to the non existing sdk.gnome.org repository, i manually switched it to the nightly repository.
Now it fails because it needs the runtime org.freedesktop.Sdk/x86_64/1.4 but the one on the repository is org.freedesktop.Sdk/x86_64/1.6

Now i have an option, to sandbox an environment and make a container, install pacaur, from there install apt in the container, and try to install monodevelop using the apt.

Now the questions:
1) is there anyway i can fix the first two steps? I really rather use pacman/aur than flatpak, and flatpak than using debian's apt on arch
2) I've seen posts on arch forum that reported apt has broken packages and dependencies on arch. would running it in a container fix that problem?
3) if i had to install it using apt, which repository should i import? cause they have different repositories for different deabian and ubuntu versions. (-.- that's why i hate their package management)

Any help toward installing monodevelop would be highly appreciated. (in the worst case scenario i have no problem compiling the source if there is any, i haven't looked that one up yet. but as mentioned, dependecies are missing, that's why i didn't look this option up)

Last edited by ExoticCandy (2021-06-28 19:38:00)

Offline

#2 2021-06-27 10:53:05

WorMzy
Forum Moderator
From: Scotland
Registered: 2010-06-16
Posts: 10,386
Website

Re: [SOLVED] Need to install monodevelop, not available on AUR

Mod note: moving to AUR Issues


Sakura:-
Mobo: MSI X299 TOMAHAWK ARCTIC // Processor: Intel Core i7-7820X 3.6GHz // GFX: AMD Radeon RX 5700 XT // RAM: 32GB (4x 8GB) Corsair DDR4 (@ 3000MHz) // Storage: 1x 3TB HDD, 6x 1TB SSD, 2x 120GB SSD, 1x 275GB M2 SSD

Making lemonade from lemons since 2015.

Offline

#3 2021-06-27 11:02:55

Lone_Wolf
Member
From: Netherlands, Europe
Registered: 2005-10-04
Posts: 9,326

Re: [SOLVED] Need to install monodevelop, not available on AUR

monodevelop aur page wrote:

Last Updated:     2020-05-22 15:28
Flagged out-of-date (2020-07-01)

Doesn't look like it's actively maintained, have you tried the alternative mentioned, https://aur.archlinux.org/packages/rider/ ?


Disliking systemd intensely, but not satisfied with alternatives so focusing on taming systemd.
Did you use the guided installer ? If yes, I can't help you.

(A works at time B)  && (time C > time B ) ≠  (A works at time C)

Offline

#4 2021-06-27 11:14:50

ExoticCandy
Member
Registered: 2021-06-24
Posts: 13

Re: [SOLVED] Need to install monodevelop, not available on AUR

Thanks for moving the topic, i was so unsure where to post.

Yea, that's sad they have abandoned the project. Ill try to read into rider and see if it fits my needs! Thanks so much.

Offline

#5 2021-06-28 19:37:18

ExoticCandy
Member
Registered: 2021-06-24
Posts: 13

Re: [SOLVED] Need to install monodevelop, not available on AUR

[Solved] [Solution]
The solution just in case someone else was wondering about the same thing:

Rider is not a FOSS project, hence, there will be users who'd rather not use it. (including me)
Monodevelop is not being maintained for arch, but actively maintained for debian/ubuntu. The solution i found for my problem was usin debootstrap (https://archlinux.org/packages/communit … bootstrap/) available in the community repository. you basically bootstrap a debian kernel inside a folder, and then follow these steps:
https://wiki.archlinux.org/title/chroot … rom_chroot

Then using chroot you open your debian environment, install monodevelop using the debian repository (through the built in apt) and run the monodevelop.

Downside: you have to put your projects inside the debian subsystem, because it is running inside a confined area, limited to that sub folder. other than that, everything works perfect. (and youll run into 0 dependency issues, since everything is installed from scratch inside your debian sub system, and it has it's own dependencies.

Edit: monodevelop needs two folders mounted from your main OS to see the running proccesses. and it wont run if it wants to show the splash. So this should do:

sudo mount -o bind /proc/ ~/DebianSUB/proc/
sudo mount -o bind /dev/pts ~/DebianSUB/dev/pts
sudo chroot ~/DebianSUB/ monodevelop --no-splash

(~/DebianSUB/ is the folder you bootstrap your debian in)

Last edited by ExoticCandy (2021-06-28 22:00:49)

Offline

#6 2021-06-29 11:10:51

Alad
Wiki Admin/IRC Op/TU
From: Bagelstan
Registered: 2014-05-04
Posts: 2,196
Website

Re: [SOLVED] Need to install monodevelop, not available on AUR

Probably easier to use systemd-nspawn than bind mout manually.


Mods are just community members who have the occasionally necessary option to move threads around and edit posts. -- Trilby
Honest Alad's Package Emporium—Now with added bugs! (Grand reopening: December 1st 2018)

Offline

#7 2021-06-30 04:47:18

thiagowfx
Member
Registered: 2013-07-09
Posts: 570

Re: [SOLVED] Need to install monodevelop, not available on AUR

@ExoticCandy You could reduce it to an one-liner if you instead do:

sudo arch-chroot ~/DebianSUB/ monodevelop --no-splash

arch-chroot is from the arch-install-scripts package, it performs all those special mounts properly (/proc, /sys, /dev/pts, etc).

That said, these days (2021!) using systemd-nspawn as suggested by Alad would indeed be a more elegant/modern solution.

Offline

#8 2021-06-30 15:28:41

ExoticCandy
Member
Registered: 2021-06-24
Posts: 13

Re: [SOLVED] Need to install monodevelop, not available on AUR

Oh!! Thanks so much for both of your responses!
I am starting to learn about "under the hood" world and reading the documentation. before Alad mentioned systemd-nspawn, i had no clue it even existed. today i gave it a test run and was so amazing!
I thought arch-chroot is only on the installation media, ill give it a try! And thanks for the suggestion! (Edit: now i see i've missed it from arch-install-scripts! Thanks so much!)

btw, the problem i faced with systemd-nspawn was that it totally bottled the debian environment, with it's own process tree. while it is GREAT for some usages (like running an untrusted application) it kind of acted coutner productive for me, cause i needed my app to interact with other processes running on the host. (arch)
Yet still there are problems i am facing, but i love reading the manual, researching and finding solutions to my problems.

Last edited by ExoticCandy (2021-06-30 15:32:58)

Offline

Board footer

Powered by FluxBB